=== src/Annotations/CMakeLists.txt ===
#
# Name of Project
#
PROJECT (Annotations)

#
# Use XML from Qt but not GUI.
#
SET(QT_DONT_USE_QTGUI TRUE)

#
# QT include files
#
if(Qt6_FOUND)
    include_directories(${Qt6Core_INCLUDE_DIRS})
    #include_directories(${Qt6Network_INCLUDE_DIRS})
    include_directories(${Qt6Xml_INCLUDE_DIRS})
endif()
if(Qt5_FOUND)
    include_directories(${Qt5Core_INCLUDE_DIRS})
    #include_directories(${Qt5Network_INCLUDE_DIRS})
    include_directories(${Qt5Xml_INCLUDE_DIRS})
endif()

###INCLUDE(${QT_USE_FILE})

#
# Create a Library
#
ADD_LIBRARY(Annotations
Annotation.h
AnnotationAlignmentEnum.h
AnnotationAndFile.h
AnnotationAttributesDefaultTypeEnum.h
AnnotationBox.h
AnnotationBrowserTab.h
AnnotationColorBar.h
AnnotationColorBarNumericText.h
AnnotationColorBarPositionModeEnum.h
AnnotationColorBarSection.h
AnnotationCoordinate.h
AnnotationCoordinateSpaceEnum.h
AnnotationDistributeEnum.h
AnnotationEditingSelectionInformation.h
AnnotationFontAttributes.h
AnnotationFontAttributesInterface.h
AnnotationGroup.h
AnnotationGroupKey.h
AnnotationGroupTypeEnum.h
AnnotationGroupingModeEnum.h
AnnotationImage.h
AnnotationLine.h
AnnotationMultiCoordinateShape.h
AnnotationMultiPairedCoordinateShape.h
AnnotationOneCoordinateShape.h
AnnotationOval.h
AnnotationPercentSizeText.h
AnnotationPointSizeText.h
AnnotationPolygon.h
AnnotationPolyhedron.h
AnnotationPolyhedronTypeEnum.h
AnnotationPolyLine.h
AnnotationRedoUndoCommand.h
AnnotationRedoUndoCommandModeEnum.h
AnnotationSampleMetaData.h
AnnotationScaleBar.h
AnnotationScaleBarTextLocationEnum.h
AnnotationScaleBarUnitsTypeEnum.h
AnnotationSizingHandleTypeEnum.h
AnnotationSpatialModification.h
AnnotationStackingOrderOperation.h
AnnotationStackingOrderTypeEnum.h
AnnotationSurfaceOffsetVectorTypeEnum.h
AnnotationText.h
AnnotationTextAlignHorizontalEnum.h
AnnotationTextAlignVerticalEnum.h
AnnotationTextConnectTypeEnum.h
AnnotationTextFontNameEnum.h
AnnotationTextFontPointSizeEnum.h
AnnotationTextFontSizeTypeEnum.h
AnnotationTextOrientationEnum.h
AnnotationTextSubstitution.h
AnnotationTwoCoordinateShape.h
AnnotationTypeEnum.h
EventAnnotationAddToRemoveFromFile.h
EventAnnotationChartLabelGet.h
EventAnnotationGroupGetWithKey.h
EventAnnotationGrouping.h
EventAnnotationPolyhedronGetByLinkedIdentifier.h
EventAnnotationPolyhedronNameComponentSettings.h
EventAnnotationTextGetBounds.h
EventAnnotationTextSubstitutionGet.h
EventAnnotationTextSubstitutionGetAllGroupIDs.h
EventAnnotationTextSubstitutionInvalidate.h
EventAnnotationValidate.h
HistologySpaceKey.h

Annotation.cxx
AnnotationAlignmentEnum.cxx
AnnotationAndFile.cxx
AnnotationAttributesDefaultTypeEnum.cxx
AnnotationBox.cxx
AnnotationBrowserTab.cxx
AnnotationColorBar.cxx
AnnotationColorBarNumericText.cxx
AnnotationColorBarPositionModeEnum.cxx
AnnotationColorBarSection.cxx
AnnotationCoordinate.cxx
AnnotationCoordinateSpaceEnum.cxx
AnnotationDistributeEnum.cxx
AnnotationEditingSelectionInformation.cxx
AnnotationFontAttributes.cxx
AnnotationGroup.cxx
AnnotationGroupKey.cxx
AnnotationGroupTypeEnum.cxx
AnnotationGroupingModeEnum.cxx
AnnotationImage.cxx
AnnotationLine.cxx
AnnotationMultiCoordinateShape.cxx
AnnotationMultiPairedCoordinateShape.cxx
AnnotationOneCoordinateShape.cxx
AnnotationOval.cxx
AnnotationPercentSizeText.cxx
AnnotationPointSizeText.cxx
AnnotationPolygon.cxx
AnnotationPolyhedron.cxx
AnnotationPolyhedronTypeEnum.cxx
AnnotationPolyLine.cxx
AnnotationRedoUndoCommand.cxx
AnnotationRedoUndoCommandModeEnum.cxx
AnnotationSampleMetaData.cxx
AnnotationScaleBar.cxx
AnnotationScaleBarTextLocationEnum.cxx
AnnotationScaleBarUnitsTypeEnum.cxx
AnnotationSizingHandleTypeEnum.cxx
AnnotationSpatialModification.cxx
AnnotationStackingOrderOperation.cxx
AnnotationStackingOrderTypeEnum.cxx
AnnotationSurfaceOffsetVectorTypeEnum.cxx
AnnotationText.cxx
AnnotationTextAlignHorizontalEnum.cxx
AnnotationTextAlignVerticalEnum.cxx
AnnotationTextConnectTypeEnum.cxx
AnnotationTextFontNameEnum.cxx
AnnotationTextFontPointSizeEnum.cxx
AnnotationTextFontSizeTypeEnum.cxx
AnnotationTextOrientationEnum.cxx
AnnotationTextSubstitution.cxx
AnnotationTwoCoordinateShape.cxx
AnnotationTypeEnum.cxx
EventAnnotationAddToRemoveFromFile.cxx
EventAnnotationChartLabelGet.cxx
EventAnnotationGroupGetWithKey.cxx
EventAnnotationGrouping.cxx
EventAnnotationPolyhedronGetByLinkedIdentifier.cxx
EventAnnotationPolyhedronNameComponentSettings.cxx
EventAnnotationTextGetBounds.cxx
EventAnnotationTextSubstitutionGet.cxx
EventAnnotationTextSubstitutionGetAllGroupIDs.cxx
EventAnnotationTextSubstitutionInvalidate.cxx
EventAnnotationValidate.cxx
HistologySpaceKey.cxx
)

TARGET_LINK_LIBRARIES(Annotations ${CARET_QT5_LINK})

#
# Find headers
#
INCLUDE_DIRECTORIES(
${CMAKE_SOURCE_DIR}/Common
${CMAKE_SOURCE_DIR}/Graphics
${CMAKE_SOURCE_DIR}/Scenes
${CMAKE_SOURCE_DIR}/Nifti
${CMAKE_SOURCE_DIR}/Xml
)
