=== src/Charting/CMakeLists.txt ===

#
# Name of Project
#
PROJECT(Charting)

#
# Qt include files
#
if(Qt6_FOUND)
    include_directories(${Qt6Core_INCLUDE_DIRS})
endif()
if(Qt5_FOUND)
    include_directories(${Qt5Core_INCLUDE_DIRS})
endif()

#
# Create a library
#
ADD_LIBRARY(Charting
ChartAxis.h
ChartAxisCartesian.h
ChartAxisLocationEnum.h
ChartAxisTypeEnum.h
ChartAxisUnitsEnum.h
ChartData.h
ChartDataCartesian.h
ChartDataSource.h
ChartDataSourceModeEnum.h
ChartMatrixDisplayProperties.h
ChartMatrixLoadingDimensionEnum.h
ChartMatrixScaleModeEnum.h
ChartModel.h
ChartModelCartesian.h
ChartModelDataSeries.h
ChartModelFrequencySeries.h
ChartModelTimeSeries.h
ChartPoint.h
ChartScaleAutoRanging.h
ChartSelectionModeEnum.h
ChartOneDataTypeEnum.h
ChartingVersionEnum.h

ChartTwoAxisOrientationTypeEnum.h
ChartTwoAxisScaleRangeModeEnum.h
ChartTwoCartesianAxis.h
ChartTwoCartesianCustomSubdivisions.h
ChartTwoCartesianCustomSubdivisionsLabel.h
ChartTwoCartesianOrientedAxes.h
ChartTwoCartesianOrientedAxesYokingManager.h
ChartTwoCartesianSubdivisionsModeEnum.h
ChartTwoCompoundDataType.h
ChartTwoDataCartesian.h
ChartTwoDataTypeEnum.h
ChartTwoHistogramContentTypeEnum.h
ChartTwoLineLayerContentTypeEnum.h
ChartTwoLineSeriesContentTypeEnum.h
ChartTwoMatrixContentTypeEnum.h
ChartTwoMatrixDisplayProperties.h
ChartTwoMatrixLoadingDimensionEnum.h
ChartTwoMatrixTriangularViewingModeEnum.h
ChartTwoNumericSubdivisionsModeEnum.h
ChartTwoLineSeriesHistory.h
ChartTwoOverlaySetInterface.h
ChartTwoTitle.h
EventChartTwoCartesianAxisDisplayGroup.h
EventChartTwoCartesianOrientedAxesYoking.h
EventChartTwoLoadLineSeriesData.h
MapFileDataSelector.h

ChartAxis.cxx
ChartAxisCartesian.cxx
ChartAxisLocationEnum.cxx
ChartAxisTypeEnum.cxx
ChartAxisUnitsEnum.cxx
ChartData.cxx
ChartDataCartesian.cxx
ChartDataSource.cxx
ChartDataSourceModeEnum.cxx
ChartMatrixDisplayProperties.cxx
ChartMatrixLoadingDimensionEnum.cxx
ChartMatrixScaleModeEnum.cxx
ChartModel.cxx
ChartModelCartesian.cxx
ChartModelDataSeries.cxx
ChartModelFrequencySeries.cxx
ChartModelTimeSeries.cxx
ChartPoint.cxx
ChartScaleAutoRanging.cxx
ChartSelectionModeEnum.cxx
ChartOneDataTypeEnum.cxx
ChartingVersionEnum.cxx

ChartTwoAxisOrientationTypeEnum.cxx
ChartTwoAxisScaleRangeModeEnum.cxx
ChartTwoCartesianAxis.cxx
ChartTwoCartesianCustomSubdivisions.cxx
ChartTwoCartesianCustomSubdivisionsLabel.cxx
ChartTwoCartesianOrientedAxes.cxx
ChartTwoCartesianOrientedAxesYokingManager.cxx
ChartTwoCartesianSubdivisionsModeEnum.cxx
ChartTwoCompoundDataType.cxx
ChartTwoDataCartesian.cxx
ChartTwoDataTypeEnum.cxx
ChartTwoHistogramContentTypeEnum.cxx
ChartTwoLineLayerContentTypeEnum.cxx
ChartTwoLineSeriesContentTypeEnum.cxx
ChartTwoMatrixContentTypeEnum.cxx
ChartTwoMatrixDisplayProperties.cxx
ChartTwoMatrixLoadingDimensionEnum.cxx
ChartTwoMatrixTriangularViewingModeEnum.cxx
ChartTwoNumericSubdivisionsModeEnum.cxx
ChartTwoLineSeriesHistory.cxx
ChartTwoOverlaySetInterface.cxx
ChartTwoTitle.cxx
EventChartTwoCartesianAxisDisplayGroup.cxx
EventChartTwoCartesianOrientedAxesYoking.cxx
EventChartTwoLoadLineSeriesData.cxx
MapFileDataSelector.cxx
)

TARGET_LINK_LIBRARIES(Charting ${CARET_QT5_LINK})

#
# Include directories
#
INCLUDE_DIRECTORIES(
${CMAKE_SOURCE_DIR}/Annotations
${CMAKE_SOURCE_DIR}/Charting
${CMAKE_SOURCE_DIR}/Common
${CMAKE_SOURCE_DIR}/Graphics
${CMAKE_SOURCE_DIR}/Scenes
)
