=== debian/watch ===
version=4
opts="uversionmangle=s/v//,filenamemangle=s/.*\/(.*)/connectome-workbench-$1/" \
  https://github.com/Washington-University/workbench/tags .*/v?(\d.*)@ARCHIVE_EXT@
# http://github.com/Washington-University/workbench/releases .*archive/v?([\d\.rc]+).tar.gz
